#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Minimize BB
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>CorG Tool>Minimize BB
#		 Note:	Only for rectangular faces
#			
#    Date:	Jun 2014
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_CorG_tools.add_item("Minimize BB") { SDM::Minimize_BB.main }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	module Minimize_BB

		def self.main
			mod = Sketchup.active_model
			ent = mod.active_entities
			sel = mod.selection
			unless sel.empty?
				mod.start_operation "Minimize BB"
				grps = sel.grep(Sketchup::ComponentInstance);
				grps.each{|grp|
					gt=grp.transformation;gn=grp.definition.name
					face = grp.definition.entities.grep(Sketchup::Face)[0]
					verts=face.outer_loop.vertices.map{|v|v.position.transform gt}
					if verts.length==4
						width=verts[0].distance(verts[1])/2
						hgt1=verts[0].distance(verts[3])/2;v1=verts[0].vector_to(verts[3])
						hgt2=verts[1].distance(verts[2])/2;v2=verts[1].vector_to(verts[2])
						mp1=verts[0].offset(v1,hgt1);mp2=verts[1].offset(v2,hgt2)
						xa=mp1.vector_to(mp2).normalize;za=face.normal.transform gt;ya=xa.cross za
						ctr = Geom::Point3d.linear_combination(0.5,mp1,0.5,mp2)
						mat=face.material
						tr=Geom::Transformation.axes(ctr,xa,ya,za)
						p0=Geom::Point3d.new()
						p1=p0.offset(X_AXIS,-width).offset(Y_AXIS,-hgt1)
						p2=p0.offset(X_AXIS, width).offset(Y_AXIS,-hgt2)
						p3=p0.offset(X_AXIS, width).offset(Y_AXIS, hgt2)
						p4=p0.offset(X_AXIS,-width).offset(Y_AXIS, hgt1)
						grp.erase!; mod.definitions.purge_unused
						grp=ent.add_group;grp.name=gn
						face=grp.entities.add_face(p1,p2,p3,p4)
						face.outer_loop.edges.each{|e|e.soft=e.smooth=true}
						face.reverse!;face.material=mat;grp.transform! tr
						cmp=grp.to_component;cmp.definition.name=gn
					else
						puts "face is not a rectangle"
					end
				}
				mod.commit_operation
			else
				UI.messagebox "Select at least one component"
			end
		end
	end
end


